require "rbconfig"
require "mkmf"

if arg_config("--mswin32") # Compiles mswin32 library on cygwin.
  $hdrdir= $topdir= $archdir= "./mswin32"
  $ARCH_FLAG= "-mno-cygwin "
  $LDFLAGS+= " -L./mswin32 "
  CONFIG["RUBY_SO_NAME"]= "msvcrt-ruby18"
  CONFIG["arch"]= "i386-mswin32"
  CONFIG["sitearch"]= "i386-mswin32"
end

if RbConfig::CONFIG["sitearch"] == "i386-msvcrt"
  # Pre-built binary exists. No need to compile.
  # Cheats on mkmf.rb not to claim about missing Makefile.
  $makefile_created= true
else
  if have_library("stdc++")
    create_makefile("tx")
  else
    $stderr.puts("-lstdc++ is required")
    exit(1)
  end
end
