// Copyright: Hiroshi Ichikawa
// Lincense: New BSD Lincense

#include <string>
#include <vector>
#include "tx.hpp"

class Builder {
    
  public:
    void add(const std::string& word);
    void add_all(const std::vector<std::string>& words);
    void build(const char* file_name);
    
  private:
    
    tx_tool::tx tx_;
    std::vector<std::string> word_list_;
    
};

class Index {
    
  public:
    
    explicit Index(const char* file_name);
    
    int longest_prefix(const char* str, int pos= 0, int len= -1, bool match_prefix= false);
    bool include(const char* str, int pos= 0, int len= -1);
    std::vector<std::string> search_prefixes(const char* str, int pos= 0, int len= -1);
    std::vector<std::string> search_expansions(const char* str, int pos= 0, int len= -1, int limit= 0);
    
  private:
    
    tx_tool::tx tx_;
    
    void validate_str(const char* str, int& pos, int& len);
    
};
