require "test/unit"
require "tempfile"
require "tx"

class TC_Tx < Test::Unit::TestCase
    
    def setup
      @builder= Tx::Builder.new()
      @builder.add_all(%w(foo ho hog hoga hoge hogeshi))
      @tempfile= Tempfile.new("tx_test")
      @builder.build(@tempfile.path)
      @index= Tx::Index.new(@tempfile.path)
    end

    def test_all
      assert_equal(4, @index.longest_prefix("hogeshaa"))
      assert_equal(6, @index.longest_prefix("hogeshaa", 0, -1, true))
      assert(@index.include("hoge"))
      assert(!@index.include("hogera"))
      assert_equal(%w(ho hog), @index.search_prefixes("hog"))
      assert_equal(%w(ho hog), @index.search_prefixes("aahog", 2, 5))
      assert_equal(%w(hoga hoge hogeshi), @index.search_expansions("hog"))
      assert_equal(%w(hoga hoge hogeshi), @index.search_expansions("aahogeshi", 2, 3))
    end
    
end
